poj3126 Prime Path 广搜bfs

时间:2023-03-09 18:38:25
poj3126 Prime Path 广搜bfs

题目:

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

问从a最少需要改变几次才能变成b,每次只能改变一位数字,且改变后的数字必须为素数。

题解:

用广搜来解决,每次都从千位到各位依次改变一位判断是否满足题目要求,满足即加入队列。

代码:

#include <iostream>
#include <stdio.h>
#include <queue>
#include <math.h>
#include <string.h>
using namespace std;
int a,b;
int turn[]; //将每次从队列中取出的数转化为数组的形式,便于改变每一位的数字
bool isprime[]; //打表,将素数记录下来
int visited[]; //判断某一数字是否出现过
int step[]; //判断每一位数字从初始状态到此翻转了几次
queue<int>q; void prime()
{
int i,j;
for(i=;i<=;i++){
for(j=;j<i;j++)
if(i%j==)
{isprime[i]=false;break;}
if(j==i) isprime[i]=true;
}
} void turned(int u)
{
int i;
for(i=;i>=;i--)
{
turn[i]=u%;
u/=;
}
} int bfs()
{
int u,i,j;
q.push(a);
visited[a]=;
while(!q.empty())
{
u=q.front();
q.pop();
if(u==b) return step[u];
turned(u); //将数字转换成数组形式
for(i=;i<;i++) //依次遍历千百十个位
{
int x=turn[i]; //x用来还原数组的数
for(j=;j<=;j++)
{
if(i==&&j==) continue;
if(j==x) continue;
turn[i]=j;
int v=turn[]*+turn[]*+turn[]*+turn[]; //v表示转换后的数
if(isprime[v]&&!visited[v])
{
step[v]=step[u]+;
visited[v]=;
q.push(v);
if(v==b) return step[v];
}
turn[i]=x; //还原
}
}
}
return -;
} int main()
{
int n;
prime();
cin>>n;
while(n--)
{
cin>>a>>b;
memset(turn,,sizeof(turn));
memset(visited,,sizeof(visited));
memset(step,,sizeof(step));
while(!q.empty())
q.pop();
int ans=bfs();
if(ans==-) printf("Impossible\n");
else cout<<ans<<endl;
}
return ;
}